(* O'Caml Freenet Client Protocol client module                     *)
(* by Travis Bemann                                                 *)
(*                                                                  *)
(* This program is free software; you can redistribute it and/or    *)
(* modify it under the terms of the GNU Lesser General Public       *)
(* License as published by the Free Software Foundation; either     *)
(* version 2 of the License, or (at your option) any later version. *)
(*                                                                  *)
(* This program is distributed in the hope that it will be useful,  *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of   *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    *)
(* GNU Lesser General Public License for more details.              *)

type field_val =
    Field_string of string
  | Field_fieldset of fieldset
and field =
    {name : string; mutable content : field_val}
and fieldset =
    field list

exception Already_exists

val field_of_name : fieldset -> string -> field
val path_split : string -> string * string
val field_of_path : fieldset -> string -> field
val has_field : fieldset -> string -> bool
val string_of_field : field -> string
val int_of_field : field -> int
val fieldset_of_field : field -> fieldset
val field_val_of_int : int -> field_val
val field_make : fieldset -> string -> field_val -> fieldset
val fields_make : fieldset -> (string * field_val) list -> fieldset
val fields_parse : string -> fieldset
val field_list_parse : string list -> fieldset
val fields_print : fieldset -> string
val fieldset_list_merge : fieldset list -> fieldset
